unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ExtCtrls, ComCtrls, Math;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    editn: TEdit;
    Dodaj: TButton;
    serien: TListBox;
    Panel2: TPanel;
    ok: TButton;
    Button1: TButton;
    PopupMenu1: TPopupMenu;
    Usu1: TMenuItem;
    pokazraport: TButton;
    Zamknij: TButton;
    GroupBox4: TGroupBox;
    zapiszwe: TCheckBox;
    zapiszwy: TCheckBox;
    progress: TProgressBar;
    dopliku: TCheckBox;
    dialog_dopliku: TSaveDialog;
    GroupBox1: TGroupBox;
    ms: TCheckBox;
    li: TCheckBox;
    lm: TCheckBox;
    nasycenie: TScrollBar;
    Label2: TLabel;
    wart_nasyc: TEdit;
    bmp: TCheckBox;
    procedure DodajClick(Sender: TObject);
    procedure Usu1Click(Sender: TObject);
    procedure editnKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure okClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pokazraportClick(Sender: TObject);
    procedure ZamknijClick(Sender: TObject);
    procedure serienKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure doplikuClick(Sender: TObject);
    procedure msClick(Sender: TObject);
    procedure nasycenieChange(Sender: TObject);
    procedure wart_nasycKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure zapiszwyClick(Sender: TObject);
  private
    { Private declarations }
  public
  end;

type zadanie =array[0..3] of char;
  // macierz sasiedztwa
     macierz_sasiedztwa = array of array of boolean;
  // lista incydencji
     plista=^lista;
     lista=record
       klucz :integer;
       nastepnik :plista;
     end;
     lista_incydencji=array of plista;

// uniwersalne funkcje i procedury grafowe
{
  DFS - przejscie grafu opisanego w strukturze ms lub li wglab, rozpoczynajac
  od wierzcholka i, zmieniajac tablice min_czasy zgodnie z trybem, tj.
  tryb= +1 - dodawanie czasu przodka+1, do czasu potomka
  tryb= -1 - odejmowanie czasu przodka+1, od czasu potomka
}
procedure DFS(ms :macierz_sasiedztwa; i :integer; tryb :integer); overload;
procedure DFS(li :lista_incydencji; i :integer; tryb :integer); overload;
procedure przed_szeregowaniem(n :integer);
function sortuj_min_czasy :plista;
function szereguj(ms :macierz_sasiedztwa) :plista; overload;
function szereguj(li :lista_incydencji) :plista; overload;
procedure usun(var ms :macierz_sasiedztwa); overload;
procedure usun(var li :lista_incydencji); overload;
procedure usun(var l :plista); overload;

// macierz sasiedztwa
procedure pomiary_macierzy_sasiedztwa(org :macierz_sasiedztwa; dane :array of zadanie);
function losuj_ms(proc_nasyc :integer; dane: array of zadanie) :macierz_sasiedztwa; // proc_nasyc, wartosc 0..100
function tworz_ms_z_ms(org: macierz_sasiedztwa) :macierz_sasiedztwa;

// lista incydencji
procedure pomiary_listy_incydencji(org :macierz_sasiedztwa; dane :array of zadanie);
function tworz_li_z_ms(org :macierz_sasiedztwa) :lista_incydencji;

// min. mozliwych innych kombinacji
function l_mozliwosci(czasy :plista) :double;

// produkowanie danych
procedure ciag_losowyunikalny(out wejscie :array of zadanie);

// inne
procedure raportuj(v :string; kolumna :integer);
function timetostr(t :TDateTime) :string;
procedure rysuj(ms :macierz_sasiedztwa; dane :array of zadanie); overload;
procedure rysuj(li :lista_incydencji; dane :array of zadanie); overload;
procedure rysuj(l :plista; dane :array of zadanie; ms :macierz_sasiedztwa); overload;
procedure zapiszwy(lista :plista; dane :array of zadanie);

var
  Form1      :TForm1;
  min_czasy  :array of integer;
  odwiedzony :array of boolean;

implementation

{$R *.dfm}

  uses Unit2, Unit3;



// ------------------------------------------------------
// uniwersalne funkcje i procedury grafowe
// ------------------------------------------------------

procedure DFS(ms :macierz_sasiedztwa; i :integer; tryb :integer);
var j :integer;
begin
if not odwiedzony[i] then
  begin
  odwiedzony[i]:=true;
  for j:=0 to high(ms) do
    if ms[j, i] then
      begin
      DFS(ms, j, tryb);                                    // RETHINK
      min_czasy[j] := min_czasy[i] +1 + min_czasy[j];
      end;
  end;
end;

procedure DFS(li :lista_incydencji; i :integer; tryb :integer);
var bw :plista; // biezacy wskaznik
begin
if not odwiedzony[i] then
  begin
  odwiedzony[i]:=true;
  bw := li[i];
  while bw<>nil do
    begin
    min_czasy[bw^.klucz] := min_czasy[bw^.klucz] + tryb*(min_czasy[i]+1);
    DFS(li, bw^.klucz, tryb);
    bw := bw^.nastepnik;
    end;
  end;
end;

procedure przed_szeregowaniem(n :integer);
begin
setLength(min_czasy, n);   // min_czasy: minimalne czasy, po jakich mozna wykonac dane zadania
setLength(odwiedzony, n);  // czy dane zadanie bylo juz odwiedzone przez DFS
while n>0 do
  begin
  dec(n);
  min_czasy[n] := 0;       // na poczatku zakladamy, ze wszystkie zadania moga byc wykonane od razu
  odwiedzony[n] := false;
  end;
end;

function sortuj_min_czasy :plista;
var i, min, lwybr, n :integer;
    pocz, wybr       :plista;
begin
n := Length(min_czasy);
i:=0;         // licznik
min:=0;       // wirtualny czas. elementy, ktore beda mialy wirtualny czas = min, beda gotowe do wykonania
lwybr := n;   // liczba zadan pozostalych do wybrania
new(wybr);    // tworzymy poczatek listy, ktora bedzie zawierac posortowane czynnosci
pocz := wybr;
wybr^.nastepnik:=nil;
while lwybr>0 do // tak dlugo, jak sa jescze elementy do wybrania
  begin
  if min_czasy[i]=min then // jesli dany element, ma czas wirtualny = aktualnemu najmniejszemu
    begin
    new(wybr^.nastepnik); // dodaj go do listy
    wybr := wybr^.nastepnik;
    wybr^.nastepnik:=nil;
    wybr^.klucz := i;
    dec(lwybr);          // zmniejszamy liczbe zadan do wybrania
    end;

  inc(i);                // przechodzimy do nastepnego zadania
  if i=n then            // jesli przekroczylismy liste elementow
    begin
    inc(min);            // ruszamy czas wirtualny o 1 do przodu
    i:=0;                // i przegladamy tablice od nowa
    end;
  end;
wybr := pocz^.nastepnik;  // ustawiamy jakis wskaznik na poczatek
dispose(pocz);            // poniewaz pierwszemu elementowi nie dalismy zadnej wartosci, usuwamy go
Result := wybr;
end;

function szereguj(ms :macierz_sasiedztwa) :plista;
var i :integer;
begin
przed_szeregowaniem(Length(ms));
for i := 0 to High(ms) do  //  dla kazdego zadania, te zadania, ktore sa jego potomkami (sprawdzi to DFS),
  DFS(ms, i, +1);     //    zostaje im zwiekszony czas wirtualny, tak ze zostana wykonane po danym zadaniu
Result := sortuj_min_czasy;
end;

function szereguj(li :lista_incydencji) :plista;
var i :integer;
begin
przed_szeregowaniem(Length(li));
for i := 0 to High(li) do
  DFS(li, i, +1);
Result := sortuj_min_czasy;
end;

procedure usun(var ms :macierz_sasiedztwa);
begin
Finalize(ms);
end;

procedure usun(var li :lista_incydencji);
var i :integer;
begin
for i := 0 to High(li) do
  usun(li[i]);
Finalize(li);
end;

procedure usun(var l :plista);
var nastepny :plista;
begin
while l<>nil do
  begin
  nastepny := l^.nastepnik;
  Dispose(l);
  l := nastepny;
  end;
end;

// ------------------------------------------------------
// macierz sasiedztwa
// ------------------------------------------------------

procedure pomiary_macierzy_sasiedztwa(org :macierz_sasiedztwa; dane :array of zadanie);
var ms    :macierz_sasiedztwa;
    wynik :plista;
    t     :TDateTime;
begin
t := time;
ms :=tworz_ms_z_ms(org);
raportuj(timetostr(time-t), 2);
form1.progress.StepIt;


t := time;
wynik :=szereguj(ms);
raportuj(timetostr(time-t), 3);
form1.progress.StepIt;

if form1.lm.Checked then
  raportuj(floattostr(l_mozliwosci(wynik)),6);
form1.progress.StepIt;

if form1.zapiszwy.Checked then
  begin
  raport.danewy.Lines.add('macierz sasiedztwa');
  if form1.bmp.Checked then
    begin
    rysuj(wynik, dane, org);
    rysuj(ms, dane);
    end;
  zapiszwy(wynik, dane);
  end;
form1.progress.StepIt;

usun(wynik);
usun(ms);
form1.progress.StepIt;
end;

function losuj_ms(proc_nasyc :integer; dane: array of zadanie) :macierz_sasiedztwa;
var ms         :macierz_sasiedztwa;
    i, j, n, p :integer;
begin
n := length(dane)-1;
setLength(ms, n+1, n+1);
for i := 0 to n do
  for j :=0 to n do
    ms[i, j] := false;

// p := n*(n-1) div 3;  // tak powinno byc zgodnie z trescia zadania
// p := n*(n-1) div 8;     // tak jest mniejsza gestosc i latwiej zrozumiec obrazki
// p := n;

p := round((n*(n-1) div 2) * (proc_nasyc / 100));

i:=1+random(n-1);
while p>0 do
  begin
//  j:=i+1+random(n-i-1);
  j := random(i-1);
  if not ms[i, j] then
    begin
    ms[i, j]:=true;
    dec(p);
    end;
  i:=1 + ((i+random(n)) mod (n));
  end;
Result := ms;
end;

function tworz_ms_z_ms(org: macierz_sasiedztwa) :macierz_sasiedztwa;
var ms      :macierz_sasiedztwa;
    i, j, n :integer;
begin
n := length(org);
setLength(ms, n, n);
for i := 0 to n-1 do
  for j:= 0 to n-1 do
    ms[i, j] := org[i, j];
Result := ms;
end;


// ------------------------------------------------------
// lista incydencji
// ------------------------------------------------------
procedure pomiary_listy_incydencji(org :macierz_sasiedztwa; dane :array of zadanie);
var li    :lista_incydencji;
    wynik :plista;
    t     :TDateTime;
begin
t := time;
li :=tworz_li_z_ms(org);
raportuj(timetostr(time-t), 4);
form1.progress.StepIt;

t := time;
wynik :=szereguj(li);
raportuj(timetostr(time-t), 5);
form1.progress.StepIt;

if form1.zapiszwy.Checked then
  begin
  raport.danewy.Lines.add('lista incydencji');
  if form1.bmp.Checked then
    begin
    rysuj(wynik, dane, org);
    rysuj(li, dane);
    end;
  zapiszwy(wynik, dane);
  end;
form1.progress.StepIt;

usun(wynik);
usun(li);
form1.progress.StepIt;
end;

function tworz_li_z_ms(org :macierz_sasiedztwa) :lista_incydencji;
var li            :lista_incydencji;
    i, j, n       :integer;
    nowy, biezacy :plista;
begin
n := Length(org);
setLength(li, n);
for i := 0 to n-1 do
  begin
  li[i] := nil;
  for j := 0 to n-1 do
    if org[i, j] then
      begin
      New(nowy);
      nowy^.klucz := j;
      nowy^.nastepnik := nil;
      if li[i]=nil then
        begin
        li[i] := nowy;
        biezacy := nowy;
        end
      else
        begin
        biezacy^.nastepnik := nowy;
        biezacy := biezacy^.nastepnik;
        end;
      end;
  end;
Result := li;
end;

// ------------------------------------------------------
// min. mozliwych innych kombinacji
// ------------------------------------------------------

function l_mozliwosci(czasy :plista) :double;
var l, w :integer;
  wynik :double;
begin
w := -1;
l := 0;
wynik := 1;
while czasy<>nil do
  begin
  if w=min_czasy[czasy^.klucz] then
    inc(l)
  else
    begin
    if l>1 then
      wynik := wynik*l;
    l:=1;
    w := min_czasy[czasy^.klucz];
    end;
  czasy := czasy^.nastepnik;
  end;
Result := wynik;
end; 

// ------------------------------------------------------
// generowanie danych
// ------------------------------------------------------

procedure ciag_losowyunikalny(out wejscie :array of zadanie);
var i, j, c, n :integer;
  tmp          :zadanie;
begin
for i :=0 to high(wejscie) do
  begin
  c:=i;
  for j:=0 to 3 do
    begin
    tmp[j]:= chr(97+(c mod 26));
    c := c div 26;
    end;
  wejscie[i] := tmp;
  end;
n := length(wejscie);
for i :=0 to high(wejscie)-1 do
  begin
  c:=i+round(random*(n-i-1));
  tmp := wejscie[i];
  wejscie[i] := wejscie[c];
  wejscie[c] := tmp;
  end;
end;

// ------------------------------------

procedure TForm1.okClick(Sender: TObject);
var numer_n, n, i, p :integer;
    f                :TextFile;
    dane             :array of zadanie;
    ms               :macierz_sasiedztwa;
begin
try
raport.wyczyscClick(sender);
form1.progress.Position:=0;
form1.progress.Max:=serien.Items.Count*3;
if form1.ms.Checked then
  form1.progress.Max:=form1.progress.Max + (5 * serien.Items.Count);
if form1.li.Checked then
  form1.progress.Max:=form1.progress.Max + (4 * serien.Items.Count);
for numer_n := 0 to serien.Items.Count-1 do
  begin
  // dla kazdego n
  raport.pomiary.Row:=numer_n+1;
  n :=strtoint(copy(serien.Items[numer_n], 0, Pos(' ', serien.Items[numer_n])-1));
  p :=strtoint(copy(serien.Items[numer_n], Pos(' ', serien.Items[numer_n])+1, Pos('%', serien.Items[numer_n])-1-Pos(' ', serien.Items[numer_n])));
  raportuj(inttostr(n), 0);
  raportuj(inttostr(p), 1);  
  setLength(dane, n);
  ciag_losowyunikalny(dane);
  form1.progress.StepIt;
  ms := losuj_ms(p, dane);
  form1.progress.StepIt;
  if zapiszwe.Checked then // zapisanie danych wejsciowych do raportu
    begin
    raport.danewe.Lines.Add('ciag losowy unikalny'+#09+inttostr(n)+#09+inttostr(p)+'%');
    for i:= low(dane) to high(dane) do
      raport.danewe.Lines.add(dane[i]);
    end;
  if zapiszwy.Checked then
      raport.danewy.Lines.Add('ciag losowy unikalny'+#09+inttostr(n)+#09+inttostr(p)+'%');
  form1.progress.StepIt;

  // macierz sasiedztwa
  if form1.ms.Checked then
    pomiary_macierzy_sasiedztwa(ms, dane);

  // lista_incydencji
  if form1.li.Checked then
    pomiary_listy_incydencji(ms, dane);

  usun(ms);
  end;

if form1.dopliku.Checked then
  begin
  {$I+}
  try
  AssignFile(f, form1.dialog_dopliku.FileName);
    try
    Append(f);
    except
    on EInOutError do
      Rewrite(f);
    end;
  for i := 0 to raport.pomiary.RowCount-1 do
    begin
    for n := 0 to raport.pomiary.ColCount-1 do
      write(f, raport.pomiary.cells[n, i]+#09);
    writeln(f);
    end;
  finally
  closefile(f);
  end;
  end;
form1.progress.Position:=0;
pokazraportClick(sender);
except
  on ex :Exception do
    showmessage('Blad: '+ex.Message);
end;
end;

//*********************************
// inne
//*********************************

function timetostr(t :TDateTime) :string;
begin
Result := inttostr(round(t*24*360000));
end;

procedure raportuj(v :string; kolumna :integer);
begin
raport.pomiary.Cells[kolumna, raport.pomiary.Row] :=v;
end;

procedure rysuj(ms :macierz_sasiedztwa; dane :array of zadanie);
var i, j :integer;
    b :TBitmap;
    nazwa :string;
    r, n, cx, cy :integer;
    function kx(i :integer) :integer;
    begin
    Result := cx + round(r*sin(2*Pi * i /(n+1)));
    end;
    function ky(i :integer) :integer;
    begin
    Result := cy + round(r*cos(2*Pi * i /(n+1)));
    end;
begin
r :=400;
n := High(ms);
nazwa := 'ms_'+inttostr(Length(ms))+'_'+inttostr(round(time*10000000))+'.bmp';
raport.danewy.Lines.Add(nazwa);
b := TBitmap.Create;
b.Width := 1000;
b.Height := 1000;
cx := 500;
cy := 500;
for i := 0 to High(ms) do
  begin
  b.Canvas.Ellipse(kx(i)-5, ky(i)-5,kx(i)+5, ky(i)+5);
  b.Canvas.TextOut(kx(i), ky(i), dane[i]);
  for j := 0 to High(ms) do
    if ms[i, j] then
      begin
      b.Canvas.MoveTo(kx(i), ky(i));
      b.Canvas.LineTo(kx(j), ky(j));
      b.Canvas.LineTo(kx(i)-5, ky(i)-5);
      end;
  end;
b.SaveToFile(nazwa);
end;

procedure rysuj(li :lista_incydencji; dane :array of zadanie);
var b :TBitmap;
    nazwa :string;
    i, x, y :integer;
    biezacy :plista;
begin
nazwa := 'li_'+inttostr(Length(li))+'_'+inttostr(round(time*10000000))+'.bmp';
raport.danewy.Lines.Add(nazwa);
b := TBitmap.Create;
b.Width := 100;
b.Height := 100;
y:=10;
for i :=0 to high(li) do
  begin
  x:=10;
  b.Canvas.Ellipse(x-10, y-5 ,x+10 ,y+5);
  b.Canvas.TextOut(x, y, dane[i]);
  biezacy := li[i];
  while biezacy<>nil do
    begin
    inc(x, 40);
    if b.width-x<=60 then b.Width := x + 60;
    b.Canvas.TextOut(x, y, dane[biezacy^.klucz]);
    b.Canvas.Ellipse(x-5, y-5 ,x+5 ,y+5);
    biezacy:=biezacy^.nastepnik;
    end;
  inc(y, 20);
  if b.Height-y<=40 then b.Height := y + 40;
  end;
b.SaveToFile(nazwa);
end;

procedure rysuj(l :plista; dane :array of zadanie; ms :macierz_sasiedztwa);
var b          :TBitmap;
    nazwa      :string;
    x, y, i, j :integer;
    lewo_poz   :array of integer;
begin
nazwa := 'plista_'+inttostr(Length(dane))+'_'+inttostr(round(time*10000000))+'.bmp';
raport.danewy.Lines.Add(nazwa);
b := TBitmap.Create;
b.Width := 1000;
b.Height := 200;
x:=100;
y:=180;
SetLength(lewo_poz, Length(dane));
while l<>nil do
  begin
  lewo_poz[l^.klucz] := x;
  b.Canvas.Ellipse(x-5, y-5 ,x+5 ,y+5);
  b.Canvas.TextOut(x, y, dane[l^.klucz]);
  inc(x, 80);
  if b.width<=x then b.width := x+ 80;
  l:=l^.nastepnik;
  end;

for i := 0 to High(ms) do
  for j := 0 to High(ms) do
    if ms[i, j] then
      begin;
      if lewo_poz[i]<lewo_poz[j] then
        begin
        x := lewo_poz[i];
        y := lewo_poz[j];
        end
      else
        begin
        x := lewo_poz[j];
        y := lewo_poz[i];
        end;
      b.Canvas.Arc(x, 20, y, 340, y, 180, x, 180);
      end;
b.SaveToFile(nazwa);
end;

procedure zapiszwy(lista :plista; dane :array of zadanie);
begin
while lista<>nil do
  begin
  raport.danewy.Lines.Add(dane[lista^.klucz]);
  lista := lista^.nastepnik;
  end;
end;

//*********************************
// interfejs
//*********************************

procedure TForm1.DodajClick(Sender: TObject);
var i :integer;
begin
try
  i :=strtoint(editn.text);
  if i>26*26*26*26 then
    showmessage('Za duze n. Zadania beda sie powtarzac.');
  serien.Items.add(editn.text+' '+IntToStr(nasycenie.position)+'%');
except
  on EConvertError do
    showmessage('n musi byc liczba!');
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
randomize;
end;

procedure TForm1.Usu1Click(Sender: TObject);
var i :integer;
begin
for i:= serien.items.count-1 downto 0 do
  begin
    if serien.Selected[i] then
      serien.Items.Delete(i);
  end;
end;

procedure TForm1.editnKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = vk_return then dodajclick(sender);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
oprogramie.show;
end;

procedure TForm1.pokazraportClick(Sender: TObject);
begin
raport.Show;
end;

procedure TForm1.ZamknijClick(Sender: TObject);
begin
if messagedlg('Napewno zamkn program?',mtConfirmation, [mbYes, mbNo], 0) = mrYes then
application.Terminate;
end;

procedure TForm1.serienKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key= vk_delete then usu1click(sender);
end;

procedure TForm1.doplikuClick(Sender: TObject);
begin
if dopliku.Checked then
  dopliku.Checked := dialog_dopliku.Execute;
end;

procedure TForm1.msClick(Sender: TObject);
begin
lm.Enabled := ms.Checked;
end;

procedure TForm1.nasycenieChange(Sender: TObject);
begin
wart_nasyc.Text := inttostr(nasycenie.Position);
end;

procedure TForm1.wart_nasycKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=vk_Return then
  try
    nasycenie.Position := strtoint(wart_nasyc.Text);
  except
    on EConvertError do
      wart_nasyc.Text := inttostr(nasycenie.position);
  end;
end;

procedure TForm1.zapiszwyClick(Sender: TObject);
begin
bmp.Enabled := zapiszwy.Checked;
end;

end.
