unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    img: TImage;
    rysuj: TButton;
    Button2: TButton;
    CheckBox1: TCheckBox;
    Button1: TButton;
    Button3: TButton;
    Button6: TButton;
    pp: TRadioButton;
    pwst: TRadioButton;
    pwzd: TRadioButton;
    Button4: TButton;
    speed: TScrollBar;
    Label1: TLabel;
    Button5: TButton;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure rysujClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  // drzewo za pomoca wskaznikow
type ref =^wezel;
     wezel =record
        klucz :integer;
        opis :string;
        potomki :array of ref;
     end;

     type myproc = procedure(t :ref);
     procedure dodajpotomka_w(t :ref);
     procedure usunpotomka_w(t :ref);
     function lisc(wartosc :integer) :ref;
     procedure us(t :ref);
     procedure rysuj_drzewo(drzewo :ref; x, y, w :integer);
     procedure przejscie_wzdluzne(t :ref; proc :myproc);
     procedure przejscie_poprzeczne(t :ref; proc :myproc);
     procedure przejscie_wsteczne(t :ref; proc :myproc);
     function szukanie_binarne(i :integer; t :ref; x, y, w :integer) :ref;

     procedure czy_binarne(t :ref);

var
  Form1: TForm1;
  drzewo  :ref;
  b :boolean;
  a1, a2 :integer;
  op :string;

implementation

uses Unit2, Unit3, Unit4;

{$R *.dfm}

function lisc(wartosc :integer) :ref;
var nowywezel :ref;
begin
  new(nowywezel);
  nowywezel^.klucz:=wartosc;
  nowywezel^.potomki:=nil;
  lisc := nowywezel;
end;

procedure dodajpotomka_w(t :ref);
begin
if (t<>nil) and (strtoint(nowy_potomek.galezklucz.Text)=t^.klucz) then
  begin
  setLength(t^.potomki, Length(t^.potomki)+1);
  t^.potomki[high(t^.potomki)] := lisc(strtoint(nowy_potomek.potomekklucz.text));
  end;
end;

procedure dpw(t :ref);
begin
if (t<>nil) and (a1=t^.klucz) then
  begin
  setLength(t^.potomki, Length(t^.potomki)+1);
  t^.potomki[high(t^.potomki)] := lisc(a2);
  t^.potomki[high(t^.potomki)].opis := op;
  end;
end;

procedure us(t :ref);
var i :integer;
begin
if (t<>nil) then
  begin
  if (length(t^.potomki)>0) then
    for i:= high(t^.potomki) to 0 do
      us(t^.potomki[i]);
  dispose(t);
  end;
end;

procedure usunpotomka_w(t :ref);
var i, j :integer;
begin
if (t<>nil) and (length(t^.potomki)>0) then
    for i:= high(t^.potomki) downto 0 do
      if (strtoint(form4.klucz.Text)=t^.potomki[i].klucz) then
        begin
        us(t^.potomki[i]);
        if i<high(t^.potomki) then
          for j:= i to high(t^.potomki) do
            t^.potomki[j] := t^.potomki[j+1];
        setLength(t^.potomki, high(t^.potomki));
        end;
end;


procedure rysuj_drzewo(drzewo :ref; x, y, w :integer);
var i, n :integer;
begin
  with form1.img do
    begin
if drzewo <> nil then
  begin
    n := length(drzewo^.potomki);
    if form1.pwzd.checked then
      begin
      if form1.CheckBox1.Checked then
        begin
        canvas.brush.Color := clred;
        canvas.Ellipse(x-5, y-5, x+5, y+5);
        canvas.brush.Color := clwhite;
        repaint;
        sleep(form1.speed.Position);
        end;
      canvas.Ellipse(x-5, y-5, x+5, y+5);
      canvas.TextOut(x-1, y-20, inttostr(drzewo^.klucz)+':'+drzewo^.opis);
      for i:=0 to high(drzewo^.potomki) do
        begin
        canvas.MoveTo(x,y+5);
        canvas.LineTo(x-(w div 2)+(w div n)*i+(w div (2*n)), y+40);
        rysuj_drzewo(drzewo^.potomki[i], x-(w div 2)+(w div n)*i+(w div (2*n)), y+40, w div n);
        end;
      end;
    if form1.pwst.checked then
      begin
      for i:=0 to high(drzewo^.potomki) do
        begin
        canvas.MoveTo(x,y+5);
        canvas.LineTo(x-(w div 2)+(w div n)*i+(w div (2*n)), y+40);
        rysuj_drzewo(drzewo^.potomki[i], x-(w div 2)+(w div n)*i+(w div (2*n)), y+40, w div n);
        end;
      if form1.CheckBox1.Checked then
        begin
        canvas.brush.Color := clred;
        canvas.Ellipse(x-5, y-5, x+5, y+5);
        canvas.brush.Color := clwhite;
        repaint;
        sleep(form1.speed.Position);
        end;
      canvas.Ellipse(x-5, y-5, x+5, y+5);
      canvas.TextOut(x-1, y-20, inttostr(drzewo^.klucz)+':'+drzewo^.opis);
      end;
    if form1.pp.checked then
      begin
      if length(drzewo^.potomki)>0 then
      for i:=0 to (high(drzewo^.potomki) div 2) do
        begin
        canvas.MoveTo(x,y+5);
        canvas.LineTo(x-(w div 2)+(w div n)*i+(w div (2*n)), y+40);
        rysuj_drzewo(drzewo^.potomki[i], x-(w div 2)+(w div n)*i+(w div (2*n)), y+40, w div n);
        end;
      if form1.CheckBox1.Checked then
        begin
        canvas.brush.Color := clred;
        canvas.Ellipse(x-5, y-5, x+5, y+5);
        canvas.brush.Color := clwhite;
        repaint;
        sleep(form1.speed.Position);
        end;
      canvas.Ellipse(x-5, y-5, x+5, y+5);
      canvas.TextOut(x-1, y-20, inttostr(drzewo^.klucz)+':'+drzewo^.opis);
      if length(drzewo^.potomki)>0 then
      for i:= (high(drzewo^.potomki) div 2) + 1 to high(drzewo^.potomki) do
        begin
        canvas.MoveTo(x,y+5);
        canvas.LineTo(x-(w div 2)+(w div n)*i+(w div (2*n)), y+40);
        rysuj_drzewo(drzewo^.potomki[i], x-(w div 2)+(w div n)*i+(w div (2*n)), y+40, w div n);
        end;
      end;
    end;
  end;
end;

procedure przejscie_wzdluzne(t :ref; proc :myproc);
var i :integer;
begin
if t<>nil then
  begin
  proc(t);
  for i := 0 to high(t^.potomki) do
    przejscie_wzdluzne(t^.potomki[i], proc);
  end;
end;

procedure przejscie_poprzeczne(t :ref; proc :myproc);
var i :integer;
begin
if t<>nil then
  begin
  for i := 0 to high(t^.potomki) do
    begin
    przejscie_wzdluzne(t^.potomki[i], proc);
    if i=high(t^.potomki) div 2 then proc(t);
    end;
  end;
end;

procedure przejscie_wsteczne(t :ref; proc :myproc);
var i :integer;
begin
if t<>nil then
  begin
  for i := 0 to high(t^.potomki) do
    przejscie_wzdluzne(t^.potomki[i], proc);
  proc(t);
  end;
end;

// traktuje drzewo jako drzewo binarne, galaz zerowa to galaz lewa,
// galaz pierwsza to galaz prawa, wszystkie nastepne galezie sa ignorowane.
function szukanie_binarne(i :integer; t :ref; x, y, w :integer) :ref;
var znaleziony :boolean;
    n :integer;
begin
while (t<>nil) and (not znaleziony) do
  begin
  n := length(t^.potomki);
  if form1.CheckBox1.Checked then
    with form1.img do
      begin
      canvas.brush.Color := clred;
      canvas.Ellipse(x-5, y-5, x+5, y+5);
      canvas.brush.Color := clwhite;
      repaint;
      sleep(form1.speed.Position);
      canvas.Ellipse(x-5, y-5, x+5, y+5);
      end;
  if t^.klucz=i then
    znaleziony :=true
  else
    if t^.klucz>i then
      begin
      if n>0 then
        t:=t^.potomki[0]
      else t:=nil;
      if (n<>0) then
        x := x-(w div 2)+(w div (2*n));
      end
        else
      begin
      if n>1 then
        t:=t^.potomki[1]
      else t:=nil;
      if (n<>0) then
        x := x-(w div 2)+(w div n)+(w div (2*n));
      end;
  y:= y+40;
  if (n<>0) then
    w :=w div n;
  end;
szukanie_binarne := t;
end;

procedure czy_binarne(t :ref);
begin
if length(t^.potomki)>2 then b := false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
drzewo := lisc(0);
rysujClick(sender);
end;

procedure TForm1.rysujClick(Sender: TObject);
begin
with form1.img do
  begin
  canvas.Pen.Color := clwhite;
  canvas.fillrect(rect(0, 0, width, height));
  canvas.Pen.Color := clblack;
  end;
rysuj_drzewo(drzewo, 5+(img.Width div 2), 30, img.Width-10);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
if nowy_potomek.ShowModal = mrOK then
  przejscie_wzdluzne(drzewo, dodajpotomka_w);
rysujclick(sender);
end;

procedure TForm1.Button3Click(Sender: TObject);
var w :ref;
begin
if form3.ShowModal = mrOK then
  begin
  w :=szukanie_binarne(strtoint(form3.klucz.text), drzewo, img.Width div 2, 20, img.Width);
  if w=nil then  showmessage('Nie znaleziono '+form3.klucz.Text)
  else showmessage('Znaleziono '+inttostr(w^.klucz));
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
if form4.ShowModal = mrOK then
  przejscie_wzdluzne(drzewo, usunpotomka_w);
rysujclick(sender);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
b:=true;
przejscie_wzdluzne(drzewo, czy_binarne);
if not b then showmessage('To drzewo nie jest binarne') else showmessage('To drzewo jest binarne');
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
a1:=0; a2:=-100; przejscie_wzdluzne(drzewo, dpw);
a1:=0; a2:=100; przejscie_wzdluzne(drzewo, dpw);
a1:=-100; a2:=-180; przejscie_wzdluzne(drzewo, dpw);
a1:=-100; a2:=-40; przejscie_wzdluzne(drzewo, dpw);
a1:=-40; a2:=-63; przejscie_wzdluzne(drzewo, dpw);
a1:=-40; a2:=-33; przejscie_wzdluzne(drzewo, dpw);
a1:=100; a2:=99; przejscie_wzdluzne(drzewo, dpw);
a1:=100; a2:=110; przejscie_wzdluzne(drzewo, dpw);
a1:=110; a2:=101; przejscie_wzdluzne(drzewo, dpw);
a1:=110; a2:=130; przejscie_wzdluzne(drzewo, dpw);
a1:=130; a2:=123; przejscie_wzdluzne(drzewo, dpw);
a1:=130; a2:=139; przejscie_wzdluzne(drzewo, dpw);
a1:=99; a2:=15; przejscie_wzdluzne(drzewo, dpw);
a1:=15; a2:=7; przejscie_wzdluzne(drzewo, dpw);
a1:=15; a2:=50; przejscie_wzdluzne(drzewo, dpw);
a1:=50; a2:=35; przejscie_wzdluzne(drzewo, dpw);
a1:=50; a2:=73; przejscie_wzdluzne(drzewo, dpw);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
speed.Enabled := checkbox1.Checked;
end;

procedure TForm1.Button5Click(Sender: TObject);
var f :TextFile;
    s : string;
    n :integer;
begin
if OpenDialog1.Execute then
  begin
  try
  AssignFile(f, opendialog1.FileName);
  Reset(f);
  n:=0;
  while not eof(f) do
    begin
    readln(f, s);
    op :=copy(s, 0, pos(' ', s));
    s:=copy(s, pos(' ', s)+1, length(s));
    a1:=strtoint(copy(s, 0, pos(' ', s)-1));
    a2:=strtoint(copy(s, pos(' ', s)+1, length(s)));
    if (n=0) then
      drzewo^.klucz:=a1;
    przejscie_wzdluzne(drzewo, dpw);
    inc(n);
    end;
  finally
    CloseFile(f);
  end;
  end;
end;

end.
