unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ExtCtrls, ComCtrls, Math;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    editn: TEdit;
    Dodaj: TButton;
    serien: TListBox;
    Panel2: TPanel;
    ok: TButton;
    Button1: TButton;
    PopupMenu1: TPopupMenu;
    Usu1: TMenuItem;
    pokazraport: TButton;
    Zamknij: TButton;
    GroupBox4: TGroupBox;
    progress: TProgressBar;
    dopliku: TCheckBox;
    dialog_dopliku: TSaveDialog;
    GroupBox1: TGroupBox;
    ae: TCheckBox;
    ah: TCheckBox;
    bmp: TCheckBox;
    jedenplan: TRadioButton;
    wszystkieplany: TRadioButton;
    zapiszwy: TCheckBox;
    procedure DodajClick(Sender: TObject);
    procedure Usu1Click(Sender: TObject);
    procedure editnKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure okClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pokazraportClick(Sender: TObject);
    procedure ZamknijClick(Sender: TObject);
    procedure serienKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure doplikuClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure bmpClick(Sender: TObject);
  private
    { Private declarations }
  public
  end;

type
  // macierz sasiedztwa
     macierz_sasiedztwa = array of array of boolean;
  // lista incydencji
     plista=^lista;
     lista=record
       klucz :integer;
       stopien :integer;
       nastepnik :plista;
       poprzednik :plista;
     end;
     lista_incydencji=array of record
        polaczenia :plista;
        odwiedzony :boolean;
     end;

// uniwersalne funkcje i procedury grafowe
function tworz_li_z_ms(org :macierz_sasiedztwa) :lista_incydencji;
procedure z_listy(var lista :plista); overload;
procedure z_listy(klucz :integer; var lista :plista); overload;
procedure do_listy(klucz :integer; var lista :plista); overload;
procedure do_listy(klucz, stopien: integer; var lista :plista); overload;
procedure usun(var ms :macierz_sasiedztwa); overload;
procedure usun(var li :lista_incydencji); overload;
procedure usun(var l :plista); overload;

// ae
procedure pomiary_ae(dane :macierz_sasiedztwa);
procedure ae(var dane :macierz_sasiedztwa; var cykl :plista; w :integer; sumapol :integer);
function lpolaczen(var dane :macierz_sasiedztwa) :integer;

// ah
procedure pomiary_ah(dane :macierz_sasiedztwa);
procedure ah(var dane :lista_incydencji; var cykl :plista; w :integer; krol :integer; wszystkie :boolean);
function hamiltonowski(cykl :plista; rozmiar :integer) :boolean;

// produkowanie danych
procedure barabasi1(var ms :macierz_sasiedztwa);
// funkcje do barbasiego
procedure polacz(var ms :macierz_sasiedztwa; a, b :integer);
procedure rozlacz(var ms :macierz_sasiedztwa; a, b :integer);
function polaczenie (var ms :macierz_sasiedztwa; a, b :integer) :boolean;
function przypadek(stopien :integer) :boolean;
function stopien(ms :macierz_sasiedztwa; w :integer) :integer;

// inne
function timetostr(t :TDateTime) :string;
procedure raportuj(v :string; kolumna :integer);
procedure rysuj(ms :macierz_sasiedztwa); overload;
procedure rysuj(li :lista_incydencji); overload;
procedure zapiszwy(lista :plista);

var
  Form1      :TForm1;
  stop       :boolean;

implementation

{$R *.dfm}

  uses Unit2, Unit3, Unit4;

function tworz_li_z_ms(org :macierz_sasiedztwa) :lista_incydencji;
var li            :lista_incydencji;
    i, j, n       :integer;
    nowy, biezacy :plista;
begin
n := Length(org);
setLength(li, n);
for i := 0 to n-1 do
  begin
  li[i].odwiedzony := false;
  li[i].polaczenia := nil;
  for j := 0 to n-1 do
    if polaczenie(org , i, j) and (i<>j) then
      begin
      New(nowy);
      nowy^.klucz := j;
      nowy^.nastepnik := nil;
      if li[i].polaczenia=nil then
        begin
        li[i].polaczenia := nowy;
        biezacy := nowy;
        end
      else
        begin
        biezacy^.nastepnik := nowy;
        biezacy := biezacy^.nastepnik;
        end;
      end;
  end;
Result := li;
end;

procedure z_listy(klucz :integer; var lista :plista);
var tmp :plista;
begin
while (lista<>nil) and (lista^.klucz<>klucz) do
  lista := lista^.nastepnik;
if lista<>nil then
  begin
  if lista^.poprzednik<>nil then
    lista^.poprzednik^.nastepnik := lista^.nastepnik;
  if lista^.nastepnik<>nil then
    begin
    lista^.nastepnik^.poprzednik := lista^.poprzednik;
    tmp := lista^.nastepnik;
    end
  else
    tmp := lista^.poprzednik;
  dispose(lista);
  lista := tmp;
  end;
end;

procedure z_listy(var lista :plista);
var tmp :plista;
begin
if lista<>nil then
  begin
  if lista^.poprzednik<>nil then
    lista^.poprzednik^.nastepnik := lista^.nastepnik;
  if lista^.nastepnik<>nil then
    begin
    lista^.nastepnik^.poprzednik := lista^.poprzednik;
    tmp := lista^.nastepnik;
    end
  else
    tmp := lista^.poprzednik;
  dispose(lista);
  lista := tmp;
  end;
end;

procedure do_listy(klucz, stopien: integer; var lista :plista);
var nowy :plista;
begin
  if lista<>nil then
    begin
      if lista^.stopien>stopien then
        do_listy(klucz, stopien, lista^.nastepnik)
      else
        begin
          New(nowy);
          nowy^.stopien := stopien;
          nowy^.klucz := klucz;
          nowy^.poprzednik := lista^.poprzednik;
          nowy^.nastepnik := lista;
          if lista^.poprzednik<>nil then
            lista^.poprzednik^.nastepnik := nowy;
          lista^.poprzednik := nowy;
          lista := nowy;
        end;
    end
  else
    begin
      New(nowy);
      nowy^.stopien := stopien;
      nowy^.klucz := klucz;
      nowy^.poprzednik := nil;
      nowy^.nastepnik := nil;
      lista := nowy;
    end;
end;

procedure do_listy(klucz :integer; var lista :plista);
begin
do_listy(klucz, random(MaxInt), lista);
end;

// ------------------------------------------------------
// uniwersalne funkcje i procedury grafowe
// ------------------------------------------------------

procedure usun(var ms :macierz_sasiedztwa);
var i :integer;
begin
for i := 0 to High(ms) do
  Finalize(ms[i]);
Finalize(ms);
end;

procedure usun(var li :lista_incydencji);
var i :integer;
begin
for i := 0 to High(li) do
  usun(li[i].polaczenia);
Finalize(li);
end;

procedure usun(var l :plista);
var nastepny :plista;
begin
while l<>nil do
  begin
  nastepny := l^.nastepnik;
  Dispose(l);
  l := nastepny;
  end;
end;

function krol(dane :macierz_sasiedztwa) :integer;
var max, stmax, i :integer;
begin
max := 0;
stmax :=0;
for i := High(dane) to 0 do
  if stopien(dane, i)>= stmax then
    begin
      max := i;
      stmax := stopien(dane, max);
    end;
Result := max;
end;

function hamiltonowski(cykl :plista; rozmiar :integer) :boolean;
var tmp :plista;
    l :integer;
begin
  l := 0;
  tmp := cykl;
  while tmp<>nil do
    begin
    Inc(l);
    tmp := tmp^.nastepnik;
    end;
  Result := l=rozmiar;
end;

procedure ah(var dane :lista_incydencji; var cykl :plista; w :integer; krol :integer; wszystkie :boolean);
var bw :plista; // biezacy wskaznik
begin
if (wszystkie) or (not stop) then
  begin
  if not dane[w].odwiedzony then
    begin
      dane[w].odwiedzony:=true;
      do_listy(w, 0, cykl);
      bw := dane[w].polaczenia;
      while bw<>nil do
        begin
          ah(dane, cykl, bw^.klucz, krol, wszystkie);
          bw := bw^.nastepnik;
        end;
      z_listy(w, cykl);
      dane[w].odwiedzony := false;
    end
  else if (w=krol) and hamiltonowski(cykl, Length(dane)) then
    begin
    stop := true;
    zapiszwy(cykl);
    end;
  end;
end;

function lpolaczen(var dane :macierz_sasiedztwa) :integer;
var i, sumapol :integer;
begin
sumapol :=0;
for i := 0 to High(dane) do
  Inc(sumapol, stopien(dane, i));
Result := sumapol div 2;
end;

procedure ae(var dane :macierz_sasiedztwa; var cykl :plista; w :integer; sumapol :integer);
var i :integer;
begin
if sumapol=0 then
  begin
    stop := true;
    zapiszwy(cykl);
  end;
form4.Label1.Caption := inttostr(sumapol);
if (not stop) then
  begin
  do_listy(w, 0, cykl);
  for i := 0 to High(dane) do
    begin
      if (w<>i) and polaczenie(dane, w, i) and (not stop) then
        begin
          rozlacz(dane, w, i);
          if form1.bmp.Checked then rysuj(dane);
          ae(dane, cykl, i, sumapol-1);
          polacz(dane, w, i);
        end;
    end;
  z_listy(cykl);
  end;
end;

procedure pomiary_ae(dane :macierz_sasiedztwa);
var wynik :plista;
    t     :TDateTime;
begin
stop :=false;
wynik := nil;
t := time;
ae(dane, wynik, krol(dane), lpolaczen(dane));
raportuj(timetostr(time-t), 1);
form1.progress.StepIt;

usun(wynik);
end;

procedure pomiary_ah(dane :macierz_sasiedztwa);
var li    :lista_incydencji;
    wynik :plista;
    t     :TDateTime;
    pole  :integer;
begin
stop := false;
li :=tworz_li_z_ms(dane);
if form1.wszystkieplany.Checked then pole := 3 else pole := 2;

wynik :=nil;
t := time;
ah(li, wynik, krol(dane), krol(dane), form1.wszystkieplany.Checked);
raportuj(timetostr(time-t), pole);
form1.progress.StepIt;

usun(wynik);
usun(li);
end;

function polaczenie (var ms :macierz_sasiedztwa; a, b :integer) :boolean;
begin
  Result := (ms[a, b] or ms[b, a] or (a=b));
end;

function stopien(ms :macierz_sasiedztwa; w :integer) :integer;
var i, j:integer;
begin
j := 0;
for i := 0 to High(ms) do
  if polaczenie(ms, w, i) then Inc(j);
Result := j-1;
end;

function nieparz(ms :macierz_sasiedztwa; w :integer) :boolean;
var k :integer;
begin
k := stopien(ms, w);
Result := (k=0) or (k mod 2=1);
end;

procedure polacz(var ms :macierz_sasiedztwa; a, b :integer);
begin
  if a>b then ms[a, b] := true
         else ms[b, a] := true;
end;

procedure rozlacz(var ms :macierz_sasiedztwa; a, b :integer);
begin
  if a>b then ms[a, b] := false
         else ms[b, a] := false;
end;

function przypadek(stopien :integer) :boolean;
begin
  Result := (stopien mod 2=1) and (random(20) <2);
end;

procedure barabasi1(var ms :macierz_sasiedztwa);
var licz :integer; // licznik wag
    wagi: array of integer;
    wezel, i, j, k :integer;
begin
  SetLength(wagi, High(ms)+1);
  wagi[3] := 50;
  for i := 0 to High(wagi) do
    wagi[i] := 0;
  licz := 54;

  for wezel := 5 to High(ms) do
    begin
      i := 3;
      while i>0 do
        begin
          k := random(licz);
          j := 0; //random(wezel);
          while polaczenie(ms, wezel, j) or (k>wagi[j]) do
            begin
            Dec(k,wagi[j]+1);
            j := (j+1) mod wezel;
            if przypadek(wagi[j]) then k :=0;
            end;
          polacz(ms, wezel, j);
          Inc(wagi[j], 21);   Inc(wagi[wezel]);
          Inc(licz, 22); Dec(i);
        end;
    end;

  repeat
    wezel := -1;
    for i := 0 to High(ms) do
      if nieparz(ms, i) then
        begin
        if wezel=-1 then
          wezel := i
        else
          begin
          if polaczenie(ms, wezel, i) then
            rozlacz(ms, wezel, i)
          else
            begin
            polacz(ms, wezel, i);
            end;
          if (stopien(ms, wezel))=1 then wezel := wezel
          else if (stopien(ms, i))=1 then wezel := i
          else wezel := -1;
          end
        end;
  until wezel=-1;
end;

// ------------------------------------

procedure TForm1.okClick(Sender: TObject);
var numer_n, n, i, j :integer;
    f                :TextFile;
    dane             :macierz_sasiedztwa;
begin
try
raport.WyczyscClick(sender);
progress.Max := 2*serien.Items.Count;
if form1.ae.Checked then progress.Max := progress.Max + serien.Items.Count;
if form1.ah.Checked then progress.Max := progress.Max + serien.Items.Count;

for numer_n := 0 to serien.Items.Count-1 do
  begin
  // dla kazdego n
  raportuj(serien.Items[numer_n], 0);
  raport.pomiary.Row:=numer_n+1;
  n :=strtoint(serien.Items[numer_n]);
  setLength(dane, n, n);
  for i := 0 to n-1 do
    for j := 0 to n-1 do
      dane[i, j] :=false;
  // generowanie do tablicy dane
  barabasi1(dane);
  progress.StepIt;

  if bmp.Checked then
    begin
      raport.danewy.Lines.Add('Lajlonia '+#09+inttostr(n));
      rysuj(dane);
    end;
  progress.StepIt;

  raport.danewy.Lines.Add('AE');
  // cykl eulera
  if form1.ae.Checked then
    pomiary_ae(dane);

  raport.danewy.Lines.Add('AH');
  // cykl hamiltona
  if form1.ah.Checked then
    pomiary_ah(dane);

  Finalize(dane);
  end;

if form1.dopliku.Checked then
  begin
  {$I+}
  try
  AssignFile(f, form1.dialog_dopliku.FileName);
    try
    Append(f);
    except
    on EInOutError do
      Rewrite(f);
    end;
  for i := 0 to raport.pomiary.RowCount-1 do
    begin
    for n := 0 to raport.pomiary.ColCount-1 do
      write(f, raport.pomiary.cells[n, i]+#09);
    writeln(f);
    end;
  finally
  closefile(f);
  end;
  end;
form1.progress.Position:=0;
pokazraportClick(sender);
except
  on ex :Exception do
    showmessage('Blad: '+ex.Message);
end;
end;

//*********************************
// inne
//*********************************

function timetostr(t :TDateTime) :string;
begin
Result := inttostr(round(t*24*360000));
end;

procedure raportuj(v :string; kolumna :integer);
begin
raport.pomiary.Cells[kolumna, raport.pomiary.Row] :=v;
end;

procedure rysuj(ms :macierz_sasiedztwa);
var i, j :integer;
    b :TBitmap;
    nazwa :string;
    r, n, cx, cy :integer;
    function kx(i :integer) :integer;
    begin
    Result := cx + round(r*sin(2*Pi * i /(n+1)));
    end;
    function ky(i :integer) :integer;
    begin
    Result := cy + round(r*cos(2*Pi * i /(n+1)));
    end;
begin
form4.Image1.Refresh; form4.Image1.Repaint; sleep(100);
n := High(ms);
r :=6*n;
nazwa := 'ms_'+inttostr(Length(ms))+'_'+inttostr(round(time*10000000))+'.bmp';
raport.danewy.Lines.Add(nazwa);
// b := TBitmap.Create;
b := form4.Image1.Picture.Bitmap;
b.Width := 2*(r+100);
b.Height := 2*(r+100);
b.Canvas.FillRect(Rect(0, 0, b.Width, b.Height));
cx := r+100;
cy := r+100;
for i := 0 to High(ms) do
  begin
  b.Canvas.Ellipse(kx(i)-5, ky(i)-5,kx(i)+5, ky(i)+5);
  b.Canvas.TextOut(kx(i), ky(i), inttostr(i)+' str.'+inttostr(stopien(ms, i)));
  for j := 0 to High(ms) do
    if ms[i, j] then
      begin
      b.Canvas.MoveTo(kx(i), ky(i));
      b.Canvas.LineTo(kx(j), ky(j));
      end;
  end;
form4.Image1.Picture.Bitmap := b;
// b.SaveToFile(nazwa);
end;

procedure rysuj(li :lista_incydencji);
var b :TBitmap;
    nazwa :string;
    i, x, y :integer;
    biezacy :plista;
begin
nazwa := 'li_'+inttostr(Length(li))+'_'+inttostr(round(time*10000000))+'.bmp';
raport.danewy.Lines.Add(nazwa);
b := TBitmap.Create;
b.Width := 100;
b.Height := 100;
y:=10;
for i :=0 to high(li) do
  begin
  x:=10;
  b.Canvas.Ellipse(x-10, y-5 ,x+10 ,y+5);
  b.Canvas.TextOut(x, y, IntToStr(i));
  biezacy := li[i].polaczenia;
  while biezacy<>nil do
    begin
    inc(x, 40);
    if b.width-x<=60 then b.Width := x + 60;
    b.Canvas.TextOut(x, y, IntToStr(biezacy^.klucz));
    b.Canvas.Ellipse(x-5, y-5 ,x+5 ,y+5);
    biezacy:=biezacy^.nastepnik;
    end;
  inc(y, 20);
  if b.Height-y<=40 then b.Height := y + 40;
  end;
b.SaveToFile(nazwa);
end;


procedure zapiszwy(lista :plista);
var s :string;
begin
if form1.zapiszwy.Checked then
  begin
  s :='';
  while lista<>nil do
    begin
    s := IntToStr(lista^.klucz)+' '+s;
    lista := lista^.nastepnik;
    end;
  raport.danewy.Lines.Add(s);
  end;
end;

//*********************************
// interfejs
//*********************************

procedure TForm1.DodajClick(Sender: TObject);
begin
try
  strtoint(editn.text);
  serien.Items.add(editn.text);
except
  on EConvertError do
    showmessage('n musi byc liczba!');
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
randomize;
end;

procedure TForm1.Usu1Click(Sender: TObject);
var i :integer;
begin
for i:= serien.items.count-1 downto 0 do
  begin
    if serien.Selected[i] then
      serien.Items.Delete(i);
  end;
end;

procedure TForm1.editnKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = vk_return then dodajclick(sender);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
oprogramie.show;
end;

procedure TForm1.pokazraportClick(Sender: TObject);
begin
raport.Show;
end;

procedure TForm1.ZamknijClick(Sender: TObject);
begin
if messagedlg('Napewno zamkn program?',mtConfirmation, [mbYes, mbNo], 0) = mrYes then
application.Terminate;
end;

procedure TForm1.serienKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key= vk_delete then usu1click(sender);
end;

procedure TForm1.doplikuClick(Sender: TObject);
begin
if dopliku.Checked then
  dopliku.Checked := dialog_dopliku.Execute;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
form4.Show;
end;

procedure TForm1.bmpClick(Sender: TObject);
begin
if bmp.Checked then form4.Show
else form4.Hide;
end;

end.
