
#ifndef STRUKTURY
#define STRUKTURY

/* stany logiczne zwracane przez funkcje */
#define FALSE 0
#define TRUE  (!FALSE)

/* stany zwracane przez aplikacje po zakonczeniu pracy */
#define APP_SUCCESS 0
#define APP_FAILED  1

/* numery semaforow */
#define SEM_LK 0 /* semafor z liczba klientow aktywnych  */
#define SEM_LL 1 /* semafor z liczba listonoszy aktywnych */
#define SEM_LS 2 /* semafor z liczba wolnych skrzynek */

/* struktura komunikatow klient<->poczta, listonosz<->poczta */
enum nadawca {NADAWCA_POCZTA=1, NADAWCA_KLIENT, NADAWCA_LISTONOSZ};
enum oper {OPER_NOWA_SKRZYNKA, OPER_USUN_SKRZYNKE, OPER_ILE_MIEJSCA, OPER_ILE_SKRZYNEK, OPER_ID_SEGMENTU};

typedef struct zapytanie {
  long      nadawca;
  int       adr_zwrotny;
  enum oper operacja;
  int       numer;
} zapytanie_t;
#define ROZM_TRESCI (sizeof(zapytanie_t)-sizeof(long))

/* struktura skrzynki */
typedef char wiadomosc_t[128];

typedef struct skrzynka {
  char         uzywana;
  int          lwiadomosci;
  wiadomosc_t* wiadomosci;
} skrzynka_t;

/* ftok */
#define SCIEZKAPOCZTA "/tmp/poczta"

#endif
