#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include "struktury.h"

char *sciezka_klienta(void) {
  char* sciezka;
  sciezka = (char*) malloc(strlen(SCIEZKA_KLIENTA)+5); /* piec znakow na pid */
  sprintf(sciezka, SCIEZKA_KLIENTA"%d", getpid());
  return sciezka;
}

int polacz(int *od_serwera, int *do_serwera) {
  int id;
  komunikat_t powitanie={0, OP_NOWE_POL};
  komunikat_arg_t powitanie_cd;
  powitanie_cd.ciag=sciezka_klienta();
  powitanie_cd.dlugosc=strlen(powitanie_cd.ciag);
  if ((*do_serwera = open(SCIEZKA_LACZA, O_WRONLY)) == -1)
    return 0;
  if (! (*od_serwera = otworz_lacze(powitanie_cd.ciag, O_RDWR)))
    return 0;
  write(*do_serwera, &powitanie, sizeof(komunikat_t));
  write(*do_serwera, &powitanie_cd.dlugosc, 1);
  write(*do_serwera, powitanie_cd.ciag, powitanie_cd.dlugosc);
  read(*od_serwera, &id, sizeof(int));
  return id;
}

void na_ekran(int serwer) {
  char znak;
  while (read(serwer, &znak, 1)) {
    putchar(znak);
  }
}

int zakupy(int do_serw, int id) {
  char buf[32];
  char kontynuluj=1;
  int czas=0;
  komunikat_t zapytanie={id, OP_NOOP};
  komunikat_arg_t argument={0, NULL};

  while (kontynuluj && fgets(buf, 32, stdin)) {
    if (strncmp("kup ", buf, 4) ==0 ) {
      zapytanie.operacja=OP_KUP;
      argument.dlugosc=strlen(buf)-5;
      argument.ciag = (char*) malloc(argument.dlugosc);
      memcpy(argument.ciag, buf+4, argument.dlugosc); /* usun "kup " z pocztku i \n z koca */
    }
    else if (strncmp("oferta\n", buf, 7) ==0 ) {
      zapytanie.operacja=OP_OFERTA;
    }
    else if (strncmp("mysle ", buf, 6) ==0 ) {
      if ((czas=atoi(buf+6))>0) {
	printf("Przerwa na mylenie: %d sekund.\n", czas);
	sleep(atoi(buf+6));
	printf("Koniec mylenia\n");
      } else {
	printf("mysle N (N czas w sekundach)\n");
      }
    }
      else if (strncmp("koniec\n", buf, 7) ==0 ) {
	zapytanie.operacja=OP_KONIEC_POL;
	kontynuluj=0;
      } else {
	printf("Nieznane polecenie. Polecenia:\n"
	       "oferta\t\t- by pozna ofert sklepu\n"
	       "mysle N\t\t- jeli chcesz chwil pomyle\n"
	       "kup NAZWA\t- aby dokona zakupu\n"
	       "koniec\t\t- aby zakoczy zakupy\n");
	fflush(stdout);
      }
    write(do_serw, &zapytanie, sizeof(komunikat_t));
    if (zapytanie.operacja == OP_KUP) {
      write(do_serw, &argument.dlugosc, 1);
      write(do_serw, argument.ciag, argument.dlugosc);
      argument.dlugosc=0;
      free(argument.ciag);
    }
  }
}

int main(void) {
  int do_serw, od_serw, id;
  if (! (id=polacz(&od_serw, &do_serw))) {
    fprintf(stderr, "Nie mona wej do sklepu. Moe nie jest wczony?\n");
    
  }

  if (fork()==0) {
    /* proces odpowiedzialny za wyswietlanie */
    na_ekran(od_serw);
  } else {
    /* proces odpowiedzialny za wysylanie zapytan do serwera (glowny) */
    zakupy(do_serw, id);
    unlink(sciezka_klienta());
  }
  return 0;
}
