
#define SCIEZKA_LACZA "/tmp/sklep_tri10o" /* sciezka lacza do sklepu */
#define SCIEZKA_KLIENTA "/tmp/sklep_klient_" /* sciezka lacza do konkretnego klienta zwiekszona o numer PID */

typedef struct towar {
  char *nazwa;
  unsigned int cena;
  unsigned int ilosc;
} towar_t;

#define OP_NOOP          0 /* brak operacji */
#define OP_NOWE_POL      1 /* otworzyc nowe lacze, ktorego nazwe przesyla klient */
#define OP_KONIEC_POL    2 /* zamknac lacze danego klienta, usunac go z listy klientow */
#define OP_OFERTA        4 /* zapytanie o oferte */
#define OP_KUP           8 /* chec kupienia towaru podanego w argumencie */

/* struktura przesylanych komunikatow. 
   nadawca     - ktory klient nadaje. zeby wiedziec, na ktore lacze odpowiedziec. 
   operacja    - jedna ze stalych OP_

   drugie slowo komunikacyjne dodatkowo: (tylko dla OP_KUP i OP_NOWE_POL)
   dlugosc - dlugosc dodatkowego argumentu ciag_arg (potrzebny w OP_KUP i OP_NOWE_POL)
   ciag    - dla OP_NOWE_POL zawiera nazwe pliku lacza, dla OP_KUP nazwe towaru
*/
typedef struct komunikat {
  int  nadawca;
  char operacja;
} komunikat_t;

typedef struct komunikat_arg {
  char dlugosc;
  char *ciag;
} komunikat_arg_t;

int otworz_lacze(char *sciezka, int flagi) {
  int lacze;
  if (mkfifo(sciezka, 0666) != 0) 
    return 0;
  if ((lacze = open(sciezka, flagi)) == -1) 
    return 0;
  return lacze;
}
