unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    editn: TEdit;
    Dodaj: TButton;
    serien: TListBox;
    GroupBox2: TGroupBox;
    cl: TCheckBox;
    cs: TCheckBox;
    cpm: TCheckBox;
    cvk: TCheckBox;
    ci: TCheckBox;
    GroupBox1: TGroupBox;
    Panel2: TPanel;
    ok: TButton;
    Button1: TButton;
    PopupMenu1: TPopupMenu;
    Usu1: TMenuItem;
    crm: TCheckBox;
    cmr: TCheckBox;
    pokazraport: TButton;
    ss: TCheckBox;
    ms: TCheckBox;
    hs: TCheckBox;
    qsi: TCheckBox;
    qsr: TCheckBox;
    Zamknij: TButton;
    GroupBox4: TGroupBox;
    zapiszwe: TCheckBox;
    zapiszwy: TCheckBox;
    progress: TProgressBar;
    dopliku: TCheckBox;
    dialog_dopliku: TSaveDialog;
    iis: TCheckBox;
    procedure DodajClick(Sender: TObject);
    procedure Usu1Click(Sender: TObject);
    procedure editnKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure okClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pokazraportClick(Sender: TObject);
    procedure ZamknijClick(Sender: TObject);
    procedure serienKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure doplikuClick(Sender: TObject);
  private
    function zrobczas(t :TDateTime) :string;
    { Private declarations }
  public
    procedure wykonaj_algorytmy(n :integer; typwe :string);
    procedure zapisz_wyjscie(typwe :string);
  end;

// produkowanie danych
procedure ciag_losowy(out wejscie :array of integer);
procedure ciag_staly(out wejscie :array of integer);
procedure ciag_posmal(out wejscie :array of integer);
procedure ciag_posros(out wejscie :array of integer);
procedure ciag_vkszta(out wejscie :array of integer);
procedure ciag_rosmal(out wejscie :array of integer);
procedure ciag_malros(out wejscie :array of integer);

// algorytmy sortowania
procedure insertionsort(il, ih :integer);
procedure selectionsort(il, ih :integer);
procedure mergesort(il, ih :integer; out wynik :array of integer);
procedure heapsort(il, ih :integer);
procedure quicksort_iter(il, ih :integer);
procedure quicksort_rekur(il, ih :integer);

var
  Form1: TForm1;
  wejscie, wetmp, wynik : array of integer;

implementation

{$R *.dfm}

  uses Unit2, Unit3;

function TForm1.zrobczas(t :TDateTime) :string;
begin
//Result := inttostr(round(t*24*360000));
Result := floattostr(t);
end;

procedure TForm1.zapisz_wyjscie(typwe :string);
var i:integer;
begin
if zapiszwy.Checked then
  begin
  raport.danewy.Lines.add(typwe);
  for i:=low(wetmp) to high(wetmp) do
    raport.danewy.lines.add(inttostr(wetmp[i]));
  end;
end;

procedure TForm1.wykonaj_algorytmy(n :integer; typwe :string);
var time0 :TdateTime;
        i :integer;
        f :TextFile;
begin
try
if dopliku.Checked then
  begin
  assignfile(f, dialog_dopliku.FileName);
  append(f);
  end;
if zapiszwe.Checked then // zapisanie danych wejsciowych do raportu
  begin
  raport.danewe.Lines.Add(typwe+#09+inttostr(n));
  for i:= low(wejscie) to high(wejscie) do
    raport.danewe.Lines.add(inttostr(wejscie[i]));
  end;
with raport do
  begin
  if iis.Checked then
    begin
    wetmp:= copy(wejscie);
    time0:=time;
    insertionsort(low(wejscie), high(wejscie));
    time0:=time-time0;
    czasy.Lines.add('insertionsort '+#09+typwe+#09+inttostr(n)+#09+zrobczas(time0));
    if dopliku.Checked then begin writeln(f, 'insertionsort '+#09+typwe+#09+inttostr(n)+#09+zrobczas(time0)); flush(f); end;
    zapisz_wyjscie('insertionsort '+#09+typwe+#09+inttostr(n));
    end;
  if ss.Checked then
    begin
    wetmp:= copy(wejscie);
    time0:=time;
    selectionsort(low(wejscie), high(wejscie));
    time0:=time-time0;
    czasy.Lines.add('selectionsort '+#09+typwe+#09+inttostr(n)+#09+zrobczas(time0));
    if dopliku.Checked then begin writeln(f, 'selectionsort '+#09+typwe+#09+inttostr(n)+#09+zrobczas(time0)); flush(f); end;
    zapisz_wyjscie('selectionsort '+#09+typwe+#09+inttostr(n));
    end;
  if ms.Checked then
    begin
    wetmp:= copy(wejscie);
    setlength(wynik, n);
    time0:=time;
    mergesort(low(wejscie), high(wejscie), wynik);
    time0:=time-time0;
    wetmp:= copy(wynik);
    czasy.Lines.add('mergesort '+#09+typwe+#09+inttostr(n)+#09+zrobczas(time0));
    if dopliku.Checked then begin writeln(f, 'mergesort '+#09+typwe+#09+inttostr(n)+#09+zrobczas(time0)); flush(f); end;
    zapisz_wyjscie('mergesort '+#09+typwe+#09+inttostr(n));
    end;
  if hs.Checked then
    begin
    wetmp:= copy(wejscie);
    time0:=time;
    heapsort(low(wejscie), high(wejscie));
    time0:=time-time0;
    czasy.Lines.add('heapsort '+#09+typwe+#09+inttostr(n)+#09+zrobczas(time0));
    if dopliku.Checked then begin writeln(f, 'heapsort '+#09+typwe+#09+inttostr(n)+#09+zrobczas(time0)); flush(f); end;
    zapisz_wyjscie('heapsort '+#09+typwe+#09+inttostr(n));
    end;
  if qsi.Checked then
    begin
    wetmp:= copy(wejscie);
    try
    time0:=time;
    quicksort_iter(low(wejscie), high(wejscie));
    time0:=time-time0;
    if dopliku.Checked then begin writeln(f, 'quicksort_iter '+#09+typwe+#09+inttostr(n)+#09+zrobczas(time0)); flush(f);  end;
    czasy.Lines.add('quicksort iter '+#09+typwe+#09+inttostr(n)+#09+zrobczas(time0));
    zapisz_wyjscie('quicksort iter '+#09+typwe+#09+inttostr(n));
    except on ex :Exception do
      begin
      if dopliku.Checked then begin writeln(f, 'quicksort_iter '+#09+typwe+#09+inttostr(n)+#09+ex.message); flush(f);  end;
      czasy.Lines.add('quicksort iter '+#09+typwe+#09+inttostr(n)+#09+ex.message);
      end;
    end;
    end;
  if qsr.Checked then
    begin
    wetmp:= copy(wejscie);
    try
    time0:=time;
    quicksort_rekur(low(wejscie), high(wejscie));
    time0:=time-time0;
    if dopliku.Checked then begin writeln(f, 'quicksort_rekur '+#09+typwe+#09+inttostr(n)+#09+zrobczas(time0)); flush(f); end;
    czasy.Lines.add('quicksort rekur '+#09+typwe+#09+inttostr(n)+#09+zrobczas(time0));
    zapisz_wyjscie('quicksort rekur '+#09+typwe+#09+inttostr(n));
    except on ex :Exception do
      begin
      if dopliku.Checked then begin writeln(f, 'quicksort_rekur '+#09+typwe+#09+inttostr(n)+#09+ex.message); flush(f);  end;
      czasy.Lines.add('quicksort rekur '+#09+typwe+#09+inttostr(n)+#09+ex.Message);
      end;
    end;
    end;
  end;
finally
  if dopliku.Checked then closefile(f);
end;
end;

procedure ciag_losowy(out wejscie :array of integer);
var i:integer;
begin
for i:= low(wejscie) to high(wejscie) do wejscie[i] := round(random*MaxInt);
end;

procedure ciag_staly(out wejscie :array of integer);
var i, c:integer;
begin
c := round(random*MaxInt);
for i:= low(wejscie) to high(wejscie) do wejscie[i] := c;
end;

procedure ciag_posmal(out wejscie :array of integer);
var i :integer;
begin
wejscie[low(wejscie)] := round(random*(MaxInt div 2)) + (MaxInt div 2);
for i :=low(wejscie)+1 to high(wejscie) do
  wejscie[i] := wejscie[i-1]-round(random*64);
end;


procedure ciag_posros(out wejscie :array of integer);
var i :integer;
begin
wejscie[low(wejscie)] := round(random*(MaxInt div 2));
for i :=low(wejscie)+1 to high(wejscie) do
  wejscie[i] := wejscie[i-1]+round(random*64);
end;

procedure ciag_vkszta(out wejscie :array of integer);
var up1, down, up2, step, i :integer;
begin
up1 := round(random*(MaxInt div 2)) + (MaxInt div 2); // \up1       /up2
down := round(random*(MaxInt div 2));                 //  \        /
up2 := round(random*(MaxInt div 2)) + (MaxInt div 2); //   \      /  -ksztaltny
wejscie[low(wejscie)] :=up1;                          //    \    /
wejscie[high(wejscie)] :=up2;                         //     \  /
wejscie[(high(wejscie)+low(wejscie)) div 2] :=down;   //      \/down
step := round((up1-down)/(((high(wejscie)+low(wejscie)) div 2) - low(wejscie)));
for i :=low(wejscie)+1 to ((high(wejscie)+low(wejscie)) div 2) -1 do
  wejscie[i] := wejscie[i-1]-step;
step := round((up2-down)/(high(wejscie) - ((high(wejscie)+low(wejscie)) div 2)));
for i := ((high(wejscie)+low(wejscie)) div 2) + 1 to high(wejscie)-1 do
  wejscie[i] := wejscie[i-1]+step;
end;


procedure ciag_rosmal(out wejscie :array of integer);
var i :integer;
begin
wejscie[low(wejscie)] := round(random*(MaxInt div 2));
if (wejscie[low(wejscie)] mod 2)=1 then inc(wejscie[low(wejscie)]);
for i := low(wejscie)+1 to high(wejscie) do
  if i<((high(wejscie)+low(wejscie)) div 2) then
    wejscie[i]:=wejscie[i-1]+2
  else
    if i=((high(wejscie)+low(wejscie)) div 2) then
      wejscie[i]:=wejscie[i-1]-1
    else
      wejscie[i]:=wejscie[i-1]-2;
end;

procedure ciag_malros(out wejscie :array of integer);
var i :integer;
begin
wejscie[low(wejscie)] := round(random*(MaxInt div 2));
if (wejscie[low(wejscie)] mod 2)=0 then inc(wejscie[low(wejscie)]);
for i := low(wejscie)+1 to high(wejscie) do
  if i<((high(wejscie)+low(wejscie)) div 2) then
    wejscie[i]:=wejscie[i-1]-2
  else
    if i=((high(wejscie)+low(wejscie)) div 2) then
      wejscie[i]:=wejscie[i-1]+1
    else
      wejscie[i]:=wejscie[i-1]+2;
end;

// algorytmy
procedure insertionsort(il, ih :integer);
var i, j, tmp :integer;
begin
for i:=1 to high(wetmp) do
  begin
  tmp:=wetmp[i]; j:=i-1;
  while tmp<wetmp[j] do
    begin
    wetmp[j+1]:=wetmp[j];
    dec(j);
    end;
  wetmp[j+1]:=tmp;
  end;
end;

procedure selectionsort(il, ih :integer);
var a, i, min, tmp :integer;
begin
for a:=il to ih-1 do
  begin
  min:=a;
  for i:=a+1 to ih do
    if wetmp[i]<wetmp[min] then
       min:=i;
  tmp:=wetmp[a];
  wetmp[a]:=wetmp[min];
  wetmp[min]:=tmp;
end;
end;

procedure mergesort(il, ih :integer; out wynik :array of integer);
var k, i, j, imax, jmax :integer;
  wynikl, wynikp :array of integer;
begin
if (ih-il)>1 then
  begin
  imax :=((ih-il) div 2);
  jmax :=ih-(il+((ih-il) div 2)+1);
  setLength(wynikl, imax+1);
  setLength(wynikp, jmax+1);
  mergesort(il, il+((ih-il) div 2), wynikl);
  mergesort(il+((ih-il) div 2)+1, ih, wynikp);
  k:=0;
  i:=0;
  j:=0;
  while (i<=imax) and (j<=jmax) do
    begin
    if wynikl[i]>wynikp[j] then
      begin
      wynik[k]:=wynikp[j];
      inc(j);
      end
    else
      begin
      wynik[k]:=wynikl[i];
      inc(i);
      end;
    inc(k);
    end;
  if i>imax then
    while j<=jmax do
      begin
      wynik[k] := wynikp[j];
      inc(j); inc(k);
      end
  else
    while i<=imax do
      begin
      wynik[k] := wynikl[i];
      inc(i); inc(k);
      end;
  end
else
  if (ih=il) then
    wynik[0]:=wetmp[il]
  else
    if (wetmp[il]>wetmp[ih]) then
      begin
      wynik[0]:=wetmp[ih];
      wynik[1]:=wetmp[il];
      end
    else
      begin
      wynik[0]:=wetmp[il];
      wynik[1]:=wetmp[ih];
      end;
end;

// heapsort - procedury
procedure kopiec_zrob(i, last :integer);
var l, r, max, tmp :integer;
begin
l := ((i+1)*2)-1;
r := (i+1)*2;
if (l<=last) and (wetmp[l]>wetmp[i]) then
  max :=l
else
  max :=i;
if (r<=last) and (wetmp[r]>wetmp[max]) then
  max := r;
if max <> i then
  begin
  tmp := wetmp[i];
  wetmp[i] := wetmp[max];
  wetmp[max] := tmp;
  kopiec_zrob(max, last);
  end;
end;

procedure heapsort(il, ih :integer);
var i, wielkosc_kopca :integer;
    tmp :integer;
begin
// robimy kopiec
for i := high(wetmp) div 2 downto 0 do
  kopiec_zrob(i, high(wetmp));
// sortujemy kopiec
wielkosc_kopca := high(wetmp);
for i:= high(wetmp) downto 1 do
  begin
  tmp := wetmp[0];
  wetmp[0] := wetmp[i];
  wetmp[i] := tmp;
  dec(wielkosc_kopca);
  kopiec_zrob(0, wielkosc_kopca);
  end;
end;

function szukajmed1(il, ih :integer) :integer; {NOT USED}
var min, max :integer;
begin
min:=wetmp[il];
max:=wetmp[il];
while il< ih do
  begin
  inc(il);
  if wetmp[il]<min then min:=wetmp[il];
  if wetmp[il]>max then max:=wetmp[il];
  end;
Result := (max+min) div 2;
end;

function szukajmed2(il, ih :integer) :integer;
begin
result := wetmp[(ih+il) div 2];
end;

procedure quicksort_iter(il, ih :integer);
type zakres =record l, p :integer; end;
var med, tmp, i, j :integer;
  s :integer;
  stos :array of zakres;
begin
s:=1;
setLength(stos, 3);
stos[s].l:=il; stos[s].p:=ih;
repeat
  il:=stos[s].l;
  ih:=stos[s].p;
  dec(s);
    repeat
    i:=il; j:=ih;
    med := wetmp[(ih+il) div 2];
    repeat
      while wetmp[i]<med do inc(i);
      while wetmp[j]>med do dec(j);
      if i<=j then
        begin
        tmp := wetmp[i];
        wetmp[i] := wetmp[j];
        wetmp[j] := tmp;
        inc(i); dec(j);
        end;
    until i>j;
    if i<ih then
      begin
        s:=s+1;
        stos[s].l:=i;
        stos[s].p:=ih;
        if s<high(stos) then setLength(stos, s+3);
      end;
    ih:=j;
  until il>=ih;
until s=0;
end;

procedure quicksort_rekur(il, ih :integer);
var med, tmp, i, j :integer;
begin
i := il;
j := ih;
med := szukajmed2(il, ih);
//med := wetmp[(ih+il) div 2];
repeat
  while wetmp[i]<med do inc(i);
  while wetmp[j]>med do dec(j);
  if i<=j then
    begin
    tmp := wetmp[i];
    wetmp[i] := wetmp[j];
    wetmp[j] := tmp;
    inc(i); dec(j);
    end;
until i>j;
if il<j then quicksort_rekur(il, j);
if i<ih then quicksort_rekur(i, ih);
end;

procedure TForm1.DodajClick(Sender: TObject);
begin
try
  strtoint(editn.text);
  serien.Items.add(editn.text);
except
  on EConvertError do
    showmessage('n musi byc liczba!');
end;
end;

procedure TForm1.Usu1Click(Sender: TObject);
var i :integer;
begin
for i:= serien.items.count-1 downto 0 do
  begin
    if serien.Selected[i] then
      serien.Items.Delete(i);
  end;
end;

procedure TForm1.editnKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = vk_return then dodajclick(sender);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
oprogramie.show;
end;

procedure TForm1.okClick(Sender: TObject);
var numer_n, n :integer;
  f :textfile;
begin
progress.Position:=0;
raport.wyczysc.Click;
progress.Max := serien.Items.Count*8;
if dopliku.Checked then
  begin
  assignfile(f, dialog_dopliku.FileName);
  rewrite(f);
  closefile(f);
  end;
for numer_n := 0 to serien.Items.Count-1 do
  begin
  n:=strtoint(serien.Items[numer_n]);
  // przygotowac dane wejsciowe
  setlength(wejscie, n);
  progress.StepIt;
  if cl.Checked  then begin ciag_losowy(wejscie); wykonaj_algorytmy(n, cl.Caption); end;
  progress.StepIt;
  if cs.Checked  then begin ciag_staly(wejscie);  wykonaj_algorytmy(n, cs.Caption); end;
  progress.StepIt;
  if cpm.Checked then begin ciag_posmal(wejscie); wykonaj_algorytmy(n, cpm.Caption); end;
  progress.StepIt;
  if ci.Checked  then begin ciag_posros(wejscie);   wykonaj_algorytmy(n, ci.Caption); end;
  progress.StepIt;
  if cvk.Checked then begin ciag_vkszta(wejscie); wykonaj_algorytmy(n, cvk.Caption); end;
  progress.StepIt;
  if crm.Checked then begin ciag_rosmal(wejscie); wykonaj_algorytmy(n, crm.Caption); end;
  progress.StepIt;
  if cmr.Checked then begin ciag_malros(wejscie); wykonaj_algorytmy(n, cmr.Caption); end;
  progress.StepIt;
  // wykonac poszczegolne algorytmy
  end;
pokazraport.Click;
progress.Position:=0;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
randomize;
end;

procedure TForm1.pokazraportClick(Sender: TObject);
begin
raport.Show;
end;

procedure TForm1.ZamknijClick(Sender: TObject);
begin
if messagedlg('Napewno zamkn program?',mtConfirmation, [mbYes, mbNo], 0) = mrYes then
application.Terminate;
end;

procedure TForm1.serienKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key= vk_delete then usu1click(sender);
end;

procedure TForm1.doplikuClick(Sender: TObject);
begin
if dopliku.Checked and dialog_dopliku.Execute then
  dopliku.Checked := true;
end;

end.
